#ifndef ATTRIBUT_HPP
#define ATTRIBUT_HPP

#include "base_attribut.hpp"
#include "xmlio_std.hpp"

class IStringStream_alt
{
	public : 
		IStringStream_alt(const std::string& str):iss(str)
		{ /* Ne rien faire de plus */}
		
		istream& operator>> (std::string& s) {s.assign(this->iss.str()); return (this->iss);}
		istream& operator>> (int& s) { return (iss>>s); }
		istream& operator>> (bool& s)
		{
			if(!this->iss.str().compare(string(".TRUE."))) s =  true;
			else s = false;
			return (this->iss);
		}
		
	private : 
		istringstream iss;
};


template <class Ctype>
   class CAttribut : public CBaseAttribut
{
  public :
  
  bool hasValue ;
  Ctype value ;

  virtual const char * getName(void) const = 0 ;
  CAttribut(void) : hasValue(false) {} ;
  CAttribut(const Ctype& value_) : value(value_), hasValue(true) {} ;
  CAttribut(const CAttribut& attr) : hasValue(attr.hasValue) 
  {
     if (hasValue) value=attr.value ;
  } ;

  CAttribut& operator = (const CAttribut & attr)
  { 
     hasValue=attr.hasValue ;
     if (hasValue) value=attr.value ;
     return *this ; 
  } ;
  
  virtual const char * getType(void) const = 0;
  
   virtual void setFromString(const std::string str) 
   { 	
	   IStringStream_alt iss(str); Ctype val;
	   iss >> val;
       this->setValue(val);
   }	

  operator Ctype()
  {
    if (!hasValue) error("CAttribut& CAttribut<Ctype>::operator Ctype")<<"access to undefined value of attribut <<"
                                                                       <<this->getName()<<">>"<<endl;
    return value ;
  } ;

  virtual ostream& print(ostream & o) const
  {
    //o<<"Attribut : "<<getName()<<"  ---->" ;
    if (hasValue) o<< boolalpha <</*" value = "<<*/value ;
    else o<< "/" ;
    return o ;
  }

  virtual void setValue(const Ctype & value_)
  {
     hasValue=true ;
     value=value_ ;
  }

  virtual void getValue(Ctype & value_) const
  {
    if (!hasValue)  error("void CAttribut<Ctype>::getValue")<<"access to undefined value of attribut <<"
                                                               <<this->getName()<<">>"<<endl;
    value_=value ;
  }

} ;


  
#endif
