#ifndef FIELD_ATTRIBUT_HPP
#define FIELD_ATTRIBUT_HPP

#include "attribut_registrar.hpp"
#include "attribut.hpp"
#include "declare_attribut.hpp"

class CFieldAttribut : public virtual CAttributRegistrar
{
	public :
   
		DECLARE_ATTR(name, string) ;
		DECLARE_ATTR(description, string) ; 
		DECLARE_ATTR(unit, string) ;
		DECLARE_ATTR(operation, string);
   
		DECLARE_ATTR(freq_op, int) ;
		DECLARE_ATTR(level, int) ;
		DECLARE_ATTR(prec, int) ;
   
		DECLARE_ATTR(enabled, bool);
   
		DECLARE_ATTR(axis_ref, string);
		DECLARE_ATTR(grid_ref, string);		
		DECLARE_ATTR(zoom_ref, string);
		DECLARE_ATTR(field_ref, string);
   
		CFieldAttribut(void)
		{
			RegisterAttribut(name) ;
			RegisterAttribut(description) ; 
			RegisterAttribut(unit) ;
			RegisterAttribut(operation);
   
			RegisterAttribut(freq_op) ;
			RegisterAttribut(level) ;
			RegisterAttribut(prec) ;
   
			RegisterAttribut(enabled);
   
			RegisterAttribut(axis_ref);
			RegisterAttribut(grid_ref);
			RegisterAttribut(zoom_ref);
			RegisterAttribut(field_ref);
		}
  
} ; // class CFieldAttribut

class CFieldGroupAttribut : public CFieldAttribut
{
	public :
  
		DECLARE_ATTR(src, string) ;
      
		CFieldGroupAttribut(void):CFieldAttribut()
		{ RegisterAttribut(src) ; }
  
} ; //class CFieldGroupAttribut

#endif //FIELD_ATTRIBUT_HPP
