/*#include "field_attribut.hpp"
#include "field.hpp"
#include "group_template.hpp"*/

#include "context.hpp"

//g++ -std=c++0x  -g  -I ../../../external/include/ -L/local/tools/svn/external/lib main_cpp.cpp stdout.cpp stdout_indent.cpp 
// ... -lPOCO_XML -lPOCO_Foundation -lpthread;

using namespace XmlIOServer;
using namespace XmlIOServer::XML;

//extern "C" void main_c_(void) ;

////////////////////////////////////////////////////////////////////

//void main_c_(void)
int main(void)
{
	//XMLParser::ClassTest(XMLTEST_PATH);

	try
	{
		XMLParser parser("/local/testsuite/iodef_test.xml");	
		std::cout << *Context::GetRootElement() << std::endl;
		parser.parse(Context::GetRootElement());	
		
		std::cout << "=============================================" << std::endl;
		
		Context::SetCurrentContext("nemo");
		
		std::cout << "ID CONTEXT 1 : "
				<< Context::GetCurrentContext()->id << std::endl;
		std::cout << "LEVEL CONTEXT 1>FieldDefinition : " 
				<< Context::GetCurrentContext()->getFieldDefinition().level.value << std::endl;
		std::cout << "FREQ_OP CONTEXT 1>FieldDefinition : " 
				<< Context::GetCurrentContext()->getFieldDefinition().freq_op.value << std::endl;
		std::cout << "AXIS_REF CONTEXT 1>FieldDefinition>grid_T : "
				<< Context::GetCurrentContext()->getFieldDefinition().getFieldGroupChild(string("grid_T"))->axis_ref.value << std::endl;
		std::cout << "DESCRIPTION CONTEXT 1>FieldDefinition>grid_T>sowaflup : "	
				<< Context::GetCurrentContext()->getFieldDefinition().getFieldGroupChild(string("grid_T"))->getFieldChild<Field*>(string("sowaflup"))->description.value << std::endl;
				
		std::cout << std::endl << "Vérification inclusion de fichier : " << std::endl;			
		
		std::cout << "UNIT CONTEXT 1>FieldDefinition>grid_U>sozotaux : "	
				<< Context::GetCurrentContext()->getFieldDefinition().getFieldGroupChild(string("grid_U"))->getFieldChild<Field*>(string("sozotaux"))->unit.value << std::endl;
		std::cout << "AXIS_REF CONTEXT 1>FieldDefinition>grid_U>vozocrtx : "	
				<< Context::GetCurrentContext()->getFieldDefinition().getFieldGroupChild(string("grid_U"))->getFieldChild<Field*>(string("vozocrtx"))->axis_ref.value << std::endl;
		
		std::cout << std::endl << "Vérification changement de context : " << std::endl;
		
		Context::SetCurrentContext("nemo_bis");
		std::cout << "ID CONTEXT 2 : "
				<< Context::GetCurrentContext()->id << std::endl;
				
		std::cout << "=============================================" << std::endl;

	}
	catch(ex_error err)
	{ std::cerr << err.what << std::endl; }
	catch (Poco::Exception& exc)
	{ std::cerr << (exc.displayText()) << std::endl; }
	
	return (0); // EXIT_SUCCESS
};
////////////////////////////////////////////////////////////////////
  

